/*
  Petr Janoušek
  Pro ČVUT FEL - Kurz Praktické Elektroniky 2020
  31.08.2020
  Tento program ukazuje funkci digitálního výstupního i vstupního pinu a práci s nimi. Při zmáčknutí tlačítka by měla LEDka svítit. Tlačítkem se pin PA_3 připojuje k zemi.
*/
#include "mbed.h"

DigitalOut led(PA_3);    // nastaví pin na který je připojena LED na digitální výstupní
DigitalIn button(PA_8);  // nastaví pin PA_3 jako digitální vstup

int main()
{
    button.mode(PullUp);         //zapne na pinu button (PA_3) vnitřní pullUp resistor. Pokud není vstupní pin připojený(když není tlačítko sepnuté), může se stát, 
                                  //že čtená hodnota na pinu bude "plavat", v podstatě bude hodnota kmitat mezi 1 a 0 podle různých vnějších rušení
                                  //(např. doteky prstů nebo přítomnost jiných elektrických zařízení v okolí) tento jev je pochopitelně nežádaný. 
                                  //PullUp resistor tedy zajistí, že při nesepnutém tlačítku bude na pinu logická 1. Pokusně si vyzkoušejte zakomentovat tento řádek a sledujte jaký to má vliv na chování LEDky. 
                                  //pokud by vás pullDown a pullUp resistory zajímaly víc, vaši starší kolegové vám určitě rádi zodpoví všechny otázky
    while(1) {
        if(button.read()==0)      //přečte stav na pinu button (PA_3) a pokud je roven logické 0, vykoná následující kód 
            {
                led.write(1);     // zapíše na pin led (PA_4) logickou 1
            }    
        else
            {
                led.write(0);    // zapíše na pin led (PA_4) logickou 0
            }
    }
}